// 
// Glow Hott pour télémesure Graupner Hott
// 
// Filtrage pour valeur compte-tours
//
// Auteur : www.thyzoon.fr 
// 2015

#include "Arduino.h"

// Filtre pour compte-tours moteur
// Filtrage median = : tri de 3 valeurs, pris en compte de la valeur mediane.
// Moyenne de 2 valeurs consécutives.
//
word median (word v) {
 
  byte i,j;
  word mini; 
  word temp;
  
  static word t0=0,t1=0,t2=0;       // Variables de memorisation car le tableau ne peut pas etre static
  word t[3];                  // tableau utilise pour le tri des valeurs
  static word val_preced =0;  // memorisation valeur precedente pour faiire la moyenne
  word filtre;                // resultat du filtrage
  
  // Decalage des 3 echantillons (2 memorisées et nouvelle valeur)
  t2 = t1;
  t1 = t0;
  t0 = v;
  
  // Transfert des 3 valeurs dans le tableau pour faire le tri
  t[0] = t0;
  t[1] = t1;
  t[2] = t2;
  
  // Tri des valeurs par ordre croissant 
  for (i=0; i<=1; i++) {
    mini = i;
    for (j=i+1; j<=2; j++) {
      if (t [j] < t [mini])
        mini = j;        
    }
    if (mini != i) { // échange
      temp = t [i];
      t [i] = t [mini];
      t [mini] = temp;
    }  
  }
  
  // Valeur médiane => t[1]
  // Moyenne des 2 derniere valeurs
  filtre = (word) ((t[1] + val_preced)/2);
  // val_preced = t[1];      // mémorisation de la valeur precedente
  val_preced = filtre;      // mémorisation de la valeur precedente  
  
  return (filtre); 
}

